summaryrefslogtreecommitdiff
path: root/src/utils/ecryptfs-rewrite-file
diff options
context:
space:
mode:
Diffstat (limited to 'src/utils/ecryptfs-rewrite-file')
-rwxr-xr-xsrc/utils/ecryptfs-rewrite-file75
1 files changed, 75 insertions, 0 deletions
diff --git a/src/utils/ecryptfs-rewrite-file b/src/utils/ecryptfs-rewrite-file
new file mode 100755
index 0000000..c4f67f5
--- /dev/null
+++ b/src/utils/ecryptfs-rewrite-file
@@ -0,0 +1,75 @@
+#!/bin/sh -e
+#
+# ecryptfs-rewrite-file
+# Copyright (C) 2008 Canonical Ltd.
+#
+# Authors: Dustin Kirkland <kirkland@ubuntu.com>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+TEXTDOMAIN="ecryptfs-utils"
+
+error() {
+ echo `gettext "[FAILED]"`
+ echo `gettext "ERROR:"` "$1" 1>&2
+}
+j=0
+OKs=0
+for i in "$@"; do
+ j=`expr $j + 1`
+ echo -n `gettext "INFO:"` `gettext "Rewriting"` "[$j/$#] [$i] ... "
+ if [ ! -e "$i" ] ; then
+ error `gettext "File does not exist"`
+ continue
+ fi
+ if [ "$i" = "." ]; then
+ echo `gettext "[EXCLUDED]"` >&2
+ continue
+ fi
+ opt=
+ if [ -d "$i" -a ! -h "$i" ]; then
+ # A directory, re-encrypt the filename
+ temp1=`mktemp -d "$i".XXXXXXXXXX` || {
+ error `gettext "Could not create tempdir"`
+ continue
+ }
+ mv -f -T "$i" "$temp1" 2>/dev/null || {
+ error `gettext "Could not rename"` "[$i] -> [$temp1]"
+ rmdir "$temp1"
+ continue
+ }
+ mv -f "$temp1" "$i" 2>/dev/null || {
+ error `gettext "Could not rename"` "[$temp1] -> [$i]"
+ }
+ else
+ # A file or symlink, re-encrypt the contents
+ temp1=`mktemp "$i".XXXXXXXXXX` || {
+ error `gettext "Could not create tempfile"`
+ continue
+ }
+ cp -a "$i" "$temp1" 2>/dev/null || {
+ error `gettext "Could not copy"` "[$i] -> [$temp1]"
+ rm -f "$temp1"
+ continue
+ }
+ mv -f "$temp1" "$i" 2>/dev/null || {
+ error `gettext "Could not rename"` "[$temp1] -> [$i]"
+ continue
+ }
+ fi
+ echo `gettext "[OK]"`
+ OKs=$((OKs+1))
+done
+echo "$OKs/$j" `gettext "rewrites succeeded"`
+[ $OKs -ne $j ] && exit 1
+exit 0